"""
Compensate for any 
"""
import abc

class Generator(metaclass=abc.ABCMeta):
	@abc.abstractmethod
	def send(self, obj):
		"""
		Send the generator the next part for the transformation.
		"""

	@abc.abstractmethod
	def throw(self, exc, val, tb):
		"""
		Pass the generator an exception.
		A raise doesn't require termination.
		"""

	@abc.abstractmethod
	def close(self):
		"""
		Shut the generator down.
		Subsequent invocations to :py:meth:`send` will fail.
		"""
import types
Generator.register(types.GeneratorType)
Generator.register((x for x in range(0)).__class__)
