"""
The process global interface registry.
"""
from . import libregistry

class Mimic(object):
	"""
	Object pretending to fulfill an implementation.

	This is useful in cases where there is a need for simple property directories.
	"""
	def __init__(self, *iid):
		self.__faces__ = set(iid)

#: The process global registry.
registry = libregistry.default()

#: Usage: @visage.lib.implementation('iid')
implementation = registry.implementation

#: Usage: @visage.lib.interface('iid')
interface = registry.interface

#: Usage: def foo() -> visage.lib.reference('iid'):
#: Provides a reference to a given Interface Identifier relative to the global registry.
reference = registry.reference

#: Usage: visage.lib.isinstance(ob, 'iid')
isinstance = registry.isinstance

#: Usage: visage.lib.defines(Class, 'iid')
isdefinition = registry.isdefinition

#: Usage: visage.lib.hasinterface(ImpClass, 'iid')
hasinterface = registry.hasinterface
