from .. import lib
from .. import libregistry

def test_protocol(test):
	test.fail_if_not_hasattr(lib, 'registry')
	test.fail_if_not_hasattr(lib, 'implementation')
	test.fail_if_not_hasattr(lib, 'hasinterface')
	test.fail_if_not_hasattr(lib, 'isinstance')
	test.fail_if_not_hasattr(lib, 'isdefinition')

	test.fail_if_not_instance(lib.registry, libregistry.Registry)

	test.fail_if_not_exact(lib.registry.implementation.__func__, lib.implementation.__func__)
	test.fail_if_not_exact(lib.registry.interface.__func__, lib.interface.__func__)
	test.fail_if_not_exact(lib.registry.isdefinition.__func__, lib.isdefinition.__func__)
	test.fail_if_not_exact(lib.registry.isinstance.__func__, lib.isinstance.__func__)
	test.fail_if_not_exact(lib.registry.hasinterface.__func__, lib.hasinterface.__func__)

	# Check some builtins.
	test.fail_if_not(lib.isinstance('foo', 'hashable'))
	test.fail_if_not(lib.isinstance([], 'iterable'))
	test.fail_if(lib.isinstance([], 'iterator'))
	test.fail_if_not(lib.isinstance(iter([]), 'iterator'))
	test.fail_if_not(lib.isinstance(set(), 'sized'))
	test.fail_if_not(lib.isinstance(lambda x: x, 'callable'))
	test.fail_if_not(lib.isinstance(set(), 'container'))
	test.fail_if_not(lib.isinstance(set(), 'set'))
	test.fail_if_not(lib.isinstance(set(), 'mutableset'))
	test.fail_if_not(lib.isinstance(dict(), 'mapping'))
	test.fail_if_not(lib.isinstance(dict(), 'mutablemapping'))
	test.fail_if_not(lib.isinstance(tuple(), 'sequence'))
	test.fail_if_not(lib.isinstance(list(), 'mutablesequence'))
	# looking at collection.Set's baseclasses
	test.fail_if_not(lib.hasinterface(set, 'container'))
	test.fail_if_not(lib.hasinterface(set, 'sized'))
	test.fail_if_not(lib.hasinterface(set, 'iterable'))

if __name__ == '__main__':
	from dev import libtest; libtest.execmodule()
